require "virtus"

module Take
  class Unit
    module AST
      class Node

        include Virtus.model

        attribute :children, Array[Node], default: proc { [] }
        attribute :name, String
        attribute :source, Source

        [:block?, :group?, :parent?, :test?, :before?, :after?, :prefix?].each do |m|
          define_method(m) { false }
        end
      end
    end
  end
end
