module Take
  module Compiler
    class Base

      def self.on_platform?
        false
      end

      def self.command
        raise NotImplementedError
      end

      def initialize
        @options = { extra: {} }
      end

      def command
        self.class.command
      end
    end
  end
end
