module Take
  module Lint
    class Error

      attr_accessor :type
      attr_accessor :file
      attr_accessor :line
      attr_accessor :column
      attr_accessor :description

      def initialize(data = {})
        data.each do |key, value|
          key = :"#{key}="

          if respond_to? key
            send key, value
          else
            raise ArgumentError, "Bad key given"
          end
        end
      end
    end
  end
end
